#use(NaviHtmlBuilder.js)

function NaviDisplay(pc, params, global_params) {
    this.init_(pc, params, global_params);
}

NaviDisplay.prototype.global_params_ = null;
NaviDisplay.prototype.init_params_ = null;
NaviDisplay.prototype.ctx_win_ = null;
NaviDisplay.prototype.first_exe_ = "";
NaviDisplay.prototype.exe_ = "";
NaviDisplay.prototype.appprofile_header_ = "";
NaviDisplay.prototype.proc_id_ = 0;
NaviDisplay.prototype.free_object_ = null;
NaviDisplay.prototype.html_builder_ = null;
NaviDisplay.prototype.key_changed_ = false;
NaviDisplay.prototype.autopilot_ = "automatic";
NaviDisplay.prototype.mtype_ = "";
NaviDisplay.prototype.elem_type_ = "";
NaviDisplay.prototype.action_ = "";
NaviDisplay.prototype.ctrlname_ = "";
NaviDisplay.prototype.ns_uid_ = "";
NaviDisplay.prototype.ask_ = [];
NaviDisplay.prototype.end_step_ = false;
NaviDisplay.prototype.cursor_changed_ = false;
NaviDisplay.prototype.last_object_ = null;
NaviDisplay.prototype.epo_data_ = [];
NaviDisplay.prototype.epo_data_index_ = 0;
NaviDisplay.prototype.import_mode_ = false;
NaviDisplay.prototype.from_file_ = [];
NaviDisplay.prototype.hot_key_ = null;
NaviDisplay.prototype.import_file = null;

NaviDisplay.prototype.init_ = function(pc, params, global_params) {

    this.end_step_ = false;
    this.global_params_ = global_params;
    this.init_params_ = params;
    this.last_object_ = null;

    this.ctx_win_ = null;
    this.exe_ = "";
    this.appprofile_header_ = "";
    this.proc_id_ = 0;
    
    this.ctrlname_ = "";
    this.ns_uid_ = "";
    this.autopilot_ = "automatic";
    this.mtype_ = "";
    this.elem_type_ = "";
    this.action_ = "";
    this.ask_ = [];
    this.from_file_ = [];
          
    this.html_builder_ = new NaviHtmlBuilder(pc, params, global_params);
    this.free_object_ = new winnavp_FreeObject();
    
    this.free_object_.objectname = "NaviDisplay";
    this.free_object_.text = this.html_builder_.GetStepNotFound(this.free_object_.objectname);
    this.free_object_.position = {x:550, y:GetScreenY()/2};
    
    var bubble = new winnavp_Bubble();

    bubble.style = this.html_builder_.BubbleClass;
    bubble.width = this.html_builder_.DisplayWidth;
    bubble.height = this.html_builder_.DisplayHght;
    bubble.minimizable = false;
    bubble.orientation = "C";
    
    this.free_object_.bubble = bubble;
    
    winnavp_player.FreeObjects.Insert(this.free_object_);
    
    this.add_global_behaviours_();
    this.epo_data_ = [];
    this.import_mode_ = EPOImportAvail();
    var import_file = GetEPOImportFile(winnavp_player.uid);
    if(this.import_mode_ && import_file != ""){
        this.load_epo_data_(import_file);
    } else {
        this.import_mode_ = false;
    }
}

NaviDisplay.prototype.load_epo_data_ = function(epo_file) {
    
    var data_table = CreateTable();
    var opened = data_table.Open(epo_file,0);
    if(opened === true){
        var rows = data_table.NumRows();
        var cols = data_table.NumCols();
        for(var i = 0 ; i < rows ; i++){
            var col_data = [];
            for(var j = 0 ; j < cols ; j++){
                col_data[j] =  data_table.GetCell(i,j);
            }
            this.epo_data_.push(col_data);
        }
        data_table.Close();
    } else {
        this.import_mode_ = false;
    }
}

NaviDisplay.prototype.revise_epo_values_ = function() {
   if(this.epo_data_index_ < this.epo_data_.length){
      var col_data = this.epo_data_[this.epo_data_index_];
      for(var i = 0 ; i < col_data.length ; i++){
          if(this.from_file_[i].import_mode){
              winnavp_ReviseValue(this.from_file_[i].obj.objectname,col_data[i]);
          }
      }
   }
}
NaviDisplay.prototype.add_global_behaviours_ = function() {
    // insert behaviour to start process
    var beh_start = new winnavp_Behaviour();
    beh_start.name = "StartAP";
    beh_start.script = 'navi_display.StartAutoPilot();';
    winnavp_behaviours.Insert(beh_start);
    
    // insert behaviour to show display
    var beh_show = new winnavp_Behaviour();
    beh_show.name = "Show" + this.free_object_.objectname;
    beh_show.script = 'var frobj = winnavp_player.FreeObjects.Find("' + this.free_object_.objectname + '");if (frobj != null) { var ret = navi_display.UpdateDisplay(); if(ret){if(navi_display.cursor_changed_) {log("Restore cursor");NavPlayer.RestoreSystemCursors(); navi_display.cursor_changed_ = false;}if(!navi_display.import_mode_) {frobj.Show();}} }';
    winnavp_behaviours.Insert(beh_show);
    
    var beh_hide = new winnavp_Behaviour();
    beh_hide.name = "Hide" + this.free_object_.objectname;
    beh_hide.script = 'var frobj = winnavp_player.FreeObjects.Find("' + this.free_object_.objectname + '");if (frobj != null) frobj.Hide();if(!navi_display.cursor_changed_) {NavPlayer.ChangeSystemCursors(); navi_display.cursor_changed_ = true;}';
    winnavp_behaviours.Insert(beh_hide);
    
    var beh_stop = new winnavp_Behaviour();
    beh_stop.name = "StopAP";
    beh_stop.script = 'navi_display.StopAutoPilot();';
    winnavp_behaviours.Insert(beh_stop);
    
    // insert assignment to activate start process
    var obj = {behaviour:beh_start.name, action:"Start", type:'global'};
    winnavp_behaviours.Assign(obj);
    
    obj = {behaviour:beh_show.name, action:"NoApp", type:'global'};
    winnavp_behaviours.Assign(obj);
    
    obj = {behaviour:beh_show.name, action:"NoPage", type:'global'};
    winnavp_behaviours.Assign(obj);
    
    obj = {behaviour:beh_hide.name, action:"PageLoad", type:'global'};
    winnavp_behaviours.Assign(obj);
    
    obj = {behaviour:beh_stop.name, action:"Stop", type:'global'};
    winnavp_behaviours.Assign(obj);
}

NaviDisplay.prototype.UpdateDisplay = function() {
    var pid = "" + this.proc_id_;
    
    if (winnavp_state.Match(pid)) {
        if(this.import_mode_){
            if(this.epo_data_index_ < this.epo_data_.length){
                navi_display.StartAutoPilot();
            }else if(!this.end_step_){
                this.free_object_.SetEditable(false);
                this.free_object_.text = this.html_builder_.ProcessEnd(this.free_object_.objectname);
                this.end_step_ = true;
                this.free_object_.Show();
            }else {
                return false;
            }
        } else {
            if (!this.end_step_) {
                this.free_object_.SetEditable(false);
                this.free_object_.text = this.html_builder_.ProcessEnd(this.free_object_.objectname);
                this.end_step_ = true;
            } else {
                return false;
            }
        }
        
    } else if (winnavp_state.variables_.length == 0) {
        return false;
    } else {
        this.free_object_.SetEditable(false);
        this.free_object_.text = this.html_builder_.GetStepNotFound(this.free_object_.objectname);
        if(this.import_mode_){
            this.free_object_.Show();
        }
    }
    
    return true;
}

NaviDisplay.prototype.SetCtxWindow = function(win, exe, profile_header) {
    
    if (this.ctx_win_ != null && win != null) {
        this.key_changed_ = (this.ctx_win_.key != win.key);
    } else {
        this.key_changed_ = false;
    }
    
    if (this.key_changed_ && this.last_object_) {
        this.last_object_.leaves_page = 1;
    }
    
    // this.key_changed_ = true;
    this.insert_autopilot_beh_();
    
    this.ctx_win_ = win;
    if (this.first_exe_ == "") {
        this.first_exe_ = exe;
    }
    this.exe_ = exe;
    this.appprofile_header_ = profile_header;
}

NaviDisplay.prototype.Finalize = function() {
    this.key_changed_ = false;
    this.insert_autopilot_beh_();
    if((this.import_mode_) && (this.from_file_.length == 0)){
        this.import_mode_ = false;
    }
}

NaviDisplay.prototype.StartAutoPilot = function() {
    this.end_step_ = false;
    winnavp_player.windows_stack_.MakeAppCurrent(this.first_exe_);
    
    if ((this.ask_.length > 0) || (this.from_file_.length > 0)){
        this.start_autopilot_();
    } else {
        NavPlayer.ChangeSystemCursors();
        this.cursor_changed_ = true;
        winnavp_RestartExt({process_id:"0", mode:"restart"});
    }
}

NaviDisplay.prototype.start_autopilot_ = function() {
    if(this.import_mode_){
        if(this.from_file_.length > 0) {
            this.revise_epo_values_();
        }
        if(this.ask_.length > 0 && this.epo_data_index_ == 0) {
            this.free_object_.SetEditable(true);
            this.free_object_.text = this.html_builder_.Ask(this.free_object_.objectname, this.ask_);
            this.free_object_.Show();
        } else {
            winnavp_player.windows_stack_.MakeAppCurrent(this.exe_); 
            Sleep(500); 
            winnavp_RestartExt({process_id:"0", mode: "restart"});
        }
        this.epo_data_index_++;
    } else {
        this.free_object_.SetEditable(true);
        this.free_object_.text = this.html_builder_.Ask(this.free_object_.objectname, this.ask_);
        this.free_object_.Show();
    }
}
NaviDisplay.prototype.StopAutoPilot = function() {
    NavPlayer.RestoreSystemCursors();
    this.epo_data_ = null;
    this.epo_data_index_ = 0;
}
NaviDisplay.prototype.InsertCtxObjectBehaviour = function(params, mtype) {
    if (curr_object != null && this.ctx_win_ != null && (curr_object.path != "" || curr_object.element_type == "WINActiveArea" || curr_object.element_type == "WINKeyPress")) {
        this.last_object_ = curr_object;
        curr_screen = new winnavp_Navigationstop();
        
        curr_screen = this.ctx_win_;
        curr_screen.process_id = "" + this.proc_id_;
        
        winnavp_player.Applications.InsertNS(curr_screen, this.exe_, this.appprofile_header_);
        
        this.proc_id_++;
        
        this.ctrlname_ = curr_object.objectname;
        this.ns_uid_ = curr_screen.uid;
        this.autopilot_ = params.autopilot;
        this.mtype_ = mtype;
        this.elem_type_ = params.element_type;
        this.action_ = params.action;
        this.key_press_ = curr_object.fieldname;
        this.hot_key_ =  curr_object.hot_key;
        
        if (this.autopilot_ == "manual") {
            if (this.mtype_ == "input_text") {
                curr_object.bubble.text = dgo_resolve(null, curr_object.bubble.text, 2) + this.html_builder_.GetOkButton(this.proc_id_);
            } else {
                curr_object.bubble.text = dgo_resolve(null, curr_object.bubble.text, 2);
                //otherwise SCN will be stopped
                curr_object.leaves_page = 1;
            }
        } else {
            curr_object.bubble.text = dgo_resolve(null, curr_object.bubble.text, 2);
        }
        
        if (this.autopilot_ == "ask") {
            this.ask_.push(curr_object);
        }
        if(this.import_mode_) {
            if(is_ask_type(curr_object.element_type)){
                if (this.autopilot_ == "from_file") {
                    this.from_file_.push({obj : curr_object, import_mode : 1});
                }
            }
            
        } else {
            if (this.autopilot_ == "from_file") {
                this.ask_.push(curr_object);
            }
        }
    }
}

NaviDisplay.prototype.insert_autopilot_beh_ = function() {

    if (this.ctrlname_ != "" && this.ns_uid_ != "") {

        if (this.autopilot_ == "manual") {
             // insert show bubble behaviour
            var show_bname = "Show" + curr_object.objectname;
            var beh_show =  new winnavp_Behaviour();
            beh_show.name = show_bname;
            beh_show.script = 'winnavp_ShowBubble("' + this.ctrlname_ + '");';
            winnavp_behaviours.Insert(beh_show);
                
            // assign show behaviour
            var obj = {behaviour:show_bname, action:"PageLoad", type:'ts', ns:this.ns_uid_};
            winnavp_behaviours.Assign(obj);
            
            // insert restart behaviour
            var restart_bname = "Restart" + this.ctrlname_;
            var beh_restart =  new winnavp_Behaviour();
            beh_restart.name = restart_bname;
            
            var mode = "validate";
            if (this.key_changed_) {
                mode = "wait"; 
                curr_object.leaves_page = 1;
            }
            
            beh_restart.script += 'winnavp_RestartExt({process_id:"' + this.proc_id_ + '", mode:"' + mode + '"});return false;';
            winnavp_behaviours.Insert(beh_restart);
                
            // assign restart behaviour
            var obj = null;
            if (this.mtype_ == "input_text" || this.mtype_ == "select_single" || 
                (this.mtype_ == "click" && (this.elem_type_ == "WINButtonCombo" || this.elem_type_ == "WINComboButtontpcd")))
            {
                obj = {behaviour:restart_bname, action:"FocusLost", type:'object', objname:this.ctrlname_};
            } else if(this.mtype_ == "key_press" && curr_screen != null && this.key_press_ != null){
                this.add_key_press_behaviour(beh_restart);
            } else {
                
                var act = "LClick";
                
                if (this.action_ == "ldblclick") {
                    act = "LDblClick";
                } else if (this.action_ == "rclick") {
                    act = "RClick";
                } else if (this.action_ == "rdblclick") {
                    act = "RDblClick";
                } else if (this.hot_key_ != null){
                    this.add_hot_key_behaviour_(beh_restart);
                }
                
                // assign behaviour to enable foe
                obj = {behaviour:restart_bname, action:act, type:'object', objname:this.ctrlname_};
            }
            
            winnavp_behaviours.Assign(obj);
        } else {
             //alert(this.mtype_ + " sec " + msec);
            // insert execute behaviour
            var exe_bname = "Exe" + this.ctrlname_;
            var beh_exe =  new winnavp_Behaviour();
            beh_exe.name = exe_bname;
            beh_exe.script = 'if (winnavp_Execute("' + this.ctrlname_ + '"))';
            beh_exe.script += 'winnavp_RestartExt({process_id:"' + this.proc_id_ + '", mode:"' 
                + (this.key_changed_ ? "wait" : "validate")  + '"});return false;';
            winnavp_behaviours.Insert(beh_exe);

                // alert(beh_exe.script);
            // assign execute behaviour
            var obj = {behaviour:exe_bname, action:"PageLoad", type:'ts', ns:this.ns_uid_};
            winnavp_behaviours.Assign(obj);
        }
    }
}

NaviDisplay.prototype.add_hot_key_behaviour_ = function(beh_restart) {
    var key_bname = "Restart" + this.ctrlname_;
    ctx_hot_key_behave = new winnavp_Behaviour();
    ctx_hot_key_behave.name = key_bname;
    ctx_hot_key_behave.script = 'if((_ctx.action.type == 3) && (_ctx.action.key_code != null) && ((_ctx.action.key_code < 160) || (_ctx.action.key_code > 165))){if(epo_validate_hot_key_(_ctx.action,"'+this.hot_key_ +'")){'+beh_restart.script +'}} else {'+beh_restart.script +'}';
    winnavp_behaviours.Insert(ctx_hot_key_behave);
    var obj = {behaviour:key_bname, action:'KeyPress', type:'ts', ns:this.ns_uid_};
    winnavp_behaviours.Assign(obj);    
}

NaviDisplay.prototype.add_key_press_behaviour = function(beh_restart) {
    ctx_key_press_behave = new winnavp_Behaviour();
    ctx_key_press_behave.name = beh_restart.name;
    ctx_key_press_behave.script = 'if((_ctx.action.key_code != null) && ((_ctx.action.key_code < 160) || (_ctx.action.key_code > 165))){if(epo_validate_hot_key_(_ctx.action,"'+this.key_press_ +'")){'+beh_restart.script +'}}';
    winnavp_behaviours.Insert(ctx_key_press_behave);
    var obj = {behaviour:ctx_key_press_behave.name, action:'KeyPress', type:'ts', ns:this.ns_uid_};
    winnavp_behaviours.Assign(obj);    
}